'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _ExceptionLoadUserException = require('./Exception/LoadUserException');

/**
 * Loads user from db
 */

var UserProvider = (function () {
  /**
   * @param {String} retrieveUserResource
   * @param {Object} deepResourceService
   */

  function UserProvider(retrieveUserResource, deepResourceService) {
    _classCallCheck(this, UserProvider);

    this._retrieveUserResource = retrieveUserResource;
    this._deepResource = deepResourceService;
  }

  /**
   * @param {String} id
   * @param {Function} callback
   * @returns {*}
   */

  _createClass(UserProvider, [{
    key: 'loadUserByIdentityId',
    value: function loadUserByIdentityId(id, callback) {
      var retrieveUserResource = this._deepResource.get(this._retrieveUserResource);

      retrieveUserResource.request({ Id: id }).send(function (response) {
        if (response.error) {
          throw new _ExceptionLoadUserException.LoadUserException(id, response.error);
        }

        return callback(JSON.parse(response.data.Payload));
      });
    }
  }]);

  return UserProvider;
})();

exports.UserProvider = UserProvider;